/* naytto.cpp */
/* Kerho-ohjelman kyttliittym.
**
**  Tekijt:          Vesa Lappalainen
**  Tehty:            09.12.1995
**
*/

#include <iostream>
#include <string>
using namespace std;
#include "naytto.h"
#include "ioali.h"
#include "dosout.h"

//----------------------------------------------------------------------------
// Vakiota
//----------------------------------------------------------------------------
#define TARKENNIN     ".dat"
#define VANHATARK     ".bak"

//----------------------------------------------------------------------------
// Nytn ksittely:
//----------------------------------------------------------------------------


void cNaytto::logo(void)
{
  cout << endl;
  cout << "      ###################################" << endl;
  cout << "      #   J  S E N R E K I S T E R I   #" << endl;
  cout << "      #     versio 9.95                 #" << endl;
  cout << "      #     Hannu Hanhi                 #" << endl;
  cout << "      ###################################" << endl;
}


void cNaytto::ohjeet(void)
{
  logo();
  cout << endl;
  cout << "Tll ohjelmalla yllpidetn kerhon jsenrekisteri." << endl;
}


void cNaytto::kiitokset(void)
{
  cout << endl;
  cout << "KIITOS KYTST JA TERVETULOA UUDELLEEN" << endl;
  cout << "\n\n" << endl;
}


int cNaytto::lue_tiedosto()
{
  cout << "Anna kerhon nimi>" << endl;
  ei_toimi();

  kerho->lue_tiedostosta("kelmit");

  return 0;
}


int cNaytto::talleta()
{
  logo();

  cout << "\n\nTosin talletus ei viel toimi!" << endl;

  return 0;
}


void cNaytto::lisaa_uusi_jasen(char valinta)
{
  otsikko(valinta,"Uuden jsenen lisys");

  ei_toimi();
}



void cNaytto::etsi_jasenen_tiedot(char valinta)
{
  otsikko(valinta,"Etsi jsenen tiedot");
  ei_toimi();
}


void cNaytto::tulosteet(char valinta)
{
  otsikko(valinta,"Tulosteet");
  cout << "Toimii toistaiseksi vain nytlle\n" << endl;
  cout << "---------------------------------------------------------" << endl;


  cout << "---------------------------------------------------------" << endl;
  odota_jotakin();
}


void cNaytto::tietojen_korjailu(char valinta)
{
  otsikko(valinta,"Tietojen korjailu");
  ei_toimi();
}


void cNaytto::paivita_jasenmaksuja(char valinta)
{
  otsikko(valinta,"Pivit jsenmaksuja");
  ei_toimi();
}


void cNaytto::avustus(char valinta)
{
  otsikko(valinta,"Avustus");
  ei_toimi();
}


void cNaytto::paamenu()
{
  cout << "\n\n\n\n" << endl;
  cout << "Jsenrekisteri" << endl;
  cout << "==============" << endl;
  cout << endl;
  cout << "Kerhossa " << kerho->Kerhon_nimi() << " on " <<
          kerho->Jasenia() << " jsent." << endl;
  cout << endl;
  cout << "Valitse:" << endl;
  cout << "   ?  = avustus" << endl;
  cout << "   0  = lopetus" << endl;
  cout << "   1  = lis uusi jsen" << endl;
  cout << "   2  = etsi jsenen tiedot" << endl;
  cout << "   3  = tulosteet" << endl;
  cout << "   4  = tietojen korjailu" << endl;
  cout << "   5  = pivit jsenmaksuja" << endl;
  cout << "   :";
}


int cNaytto::paavalinta()
{
  char nappain;

  while (1) {

    paamenu();

    nappain = odota_nappain("?012345",EI_OLETUSTA,MERKKI_ISOKSI);

    switch (nappain) {
      case '?': avustus(nappain);               break;
      case '0': return 0;
      case '1': lisaa_uusi_jasen(nappain);      break;
      case '2': etsi_jasenen_tiedot(nappain);   break;
      case '3': tulosteet(nappain);             break;
      case '4': tietojen_korjailu(nappain);     break;
      case '5': paivita_jasenmaksuja(nappain);  break;
      default : cout << "Nin ei voi kyd!" << endl; return 1;
    }

  }
}

