/* nayttote.cpp */
/* Kerho-ohjelman menut ja toimintojen rungot.
**  Tekijt:          Vesa Lappalainen
**                    Ohjelmointikurssi 1996
**  Tehty:            6.12.1995
**  Muutettu          22.01.2000/vl
**  Mit muutettu:    aliohjelmat muutettu cNaytto-luokan metodeiksi
**
**  Tehtvi: 1) "Paliohjelmien" avustus, tulosta jne. alussa toistuu
**               samat lauseet.  Tee aliohjelma otsikko, jonka avulla ko.
**               aliohjelmat saadaan 2 rivin mittaisiksi.
**
**            2) Miksi aliohjelmiin avustus, tulosta jne viedn painettu
**               nppin parametrina.  Miksei tulosteta suoraan:
**                 "?.  Avustus"
**
*/

#include <iostream>
#include <cstdlib>
#include <string>
using namespace std;
#include "dosout.h"

//----------------------------------------------------------------------------
#define MERKKI_ISOKSI 1
#define KAIKKI_KELPAA NULL
#define EI_OLETUSTA   0
#define RIVINVAIHTO   "\r\n"

//----------------------------------------------------------------------------
// Yleiskyttisi apualiohjelmia:
//----------------------------------------------------------------------------

#ifdef __TURBOC__               /* Sytt Turbo-C:n mukaisesti.             */
# define GETCH
# include <conio.h>
#endif

char lue_merkki(void)
{
/* Seuraava toimii mm. Turbo C:ss: */
#ifdef GETCH
  char c;
  while ( 1 ) { /* Korjataan funktionppin-vika */
    c = (char)getch();
    if ( c != 0 ) return c;
    c = (char)getch();
  }

#else

/* Seuraava on standardin mukainen: */
  char s[50];
  fgets(s,50,stdin);
  return s[0];
#endif

}

char isoksi(char c)
{
  if ( c<'a' ) return c;
  if ( c>'z' ) return c;
  return (char)(c-('a'-'A'));
}

char odota_nappain(const char *kelpaavat, char oletus, int isot)
{
  char painettu;
  do {
    while ( (painettu=lue_merkki()) == 0 ); /* HUOM! korjaus! */
    if (isot) painettu = isoksi(painettu);
    if ( oletus && ((painettu=='\n') || (painettu=='\r')) )
      return oletus;
  } while ( kelpaavat && !strchr(kelpaavat,painettu) );
  return painettu;
}


void odota_jotakin(void)
{
  cout << "Paina jotakin!" << endl;
  odota_nappain(KAIKKI_KELPAA,EI_OLETUSTA,MERKKI_ISOKSI);
}


int kylla_vastaus(void)
{
  return (odota_nappain("KE",'K',MERKKI_ISOKSI)=='K');
}


void ei_toimi(void)
{
  cout << "Ei toimi viel!" << endl;
  odota_jotakin();
}

void viiva(int pit, char merkki)
{
  for (int i = 0; i<pit; i++)
    cout << merkki;
}


void otsikko(char c,const char *teksti)
{
  cout << "\n\n\n" << endl;
  cout << c << ".  " << teksti << endl;
  viiva(  1  +  3     + strlen(teksti),'=');
  cout << "\n" << endl;
}


int ilmoitus(const char *s)
{
  if ( s == NULL ) return 0;
  cout << "\n" << s << endl;
  odota_jotakin();
  return 1;
}


//----------------------------------------------------------------------------
class cKerho { // Kerholuokka, jota viel paljon korjataan
  string kerhon_nimi;
  int    jasenia;
public:
  cKerho() { kerhon_nimi = "Kelmien kerho"; jasenia = 5;  }            
  const string &Kerhon_nimi()    const   { return kerhon_nimi;               }
  int Jasenia()                  const   { return jasenia;                   }
};


//----------------------------------------------------------------------------
// Nytn mrittely
//----------------------------------------------------------------------------
class cNaytto {
  cKerho *kerho; // Osoitin kerhoon => voi olla sama kerho monessa nytss

  void logo(void);
  void avustus(char valinta);
  void lisaa_uusi_jasen(char valinta);
  void etsi_jasenen_tiedot(char valinta);
  void tulosteet(char valinta);
  void tietojen_korjailu(char valinta);
  void paivita_jasenmaksuja(char valinta);
  void paamenu();
public:
  cNaytto(cKerho *p) : kerho(p) {;}
  ~cNaytto() { talleta(); }

  void ohjeet(void);
  void kiitokset(void);

  int  lue_tiedosto();
  int  talleta();

  int  paavalinta();
};


void cNaytto::logo(void)
{
  cout << endl;
  cout << "      ###################################" << endl;
  cout << "      #   J  S E N R E K I S T E R I   #" << endl;
  cout << "      #     versio 9.95                 #" << endl;
  cout << "      #     Hannu Hanhi                 #" << endl;
  cout << "      ###################################" << endl;
}


void cNaytto::ohjeet(void)
{
  logo();
  cout << endl;
  cout << "Tll ohjelmalla yllpidetn kerhon jsenrekisteri." << endl;
}


void cNaytto::kiitokset(void)
{
  cout << endl;
  cout << "KIITOS KYTST JA TERVETULOA UUDELLEEN" << endl;
  cout << "\n\n" << endl;
}


int cNaytto::lue_tiedosto()
{
  cout << "Anna kerhon nimi>" << endl;
  ei_toimi();

  return 0;
}


int cNaytto::talleta()
{
  logo();

  cout << "\n\nTosin talletus ei viel toimi!" << endl;

  return 0;
}


void cNaytto::lisaa_uusi_jasen(char valinta)
{
  otsikko(valinta,"Uuden jsenen lisys");

  ei_toimi();
}



void cNaytto::etsi_jasenen_tiedot(char valinta)
{
  otsikko(valinta,"Etsi jsenen tiedot");
  ei_toimi();
}


void cNaytto::tulosteet(char valinta)
{
  otsikko(valinta,"Tulosteet");
  cout << "Toimii toistaiseksi vain nytlle\n" << endl;
  cout << "---------------------------------------------------------" << endl;


  cout << "---------------------------------------------------------" << endl;
  odota_jotakin();
}


void cNaytto::tietojen_korjailu(char valinta)
{
  otsikko(valinta,"Tietojen korjailu");
  ei_toimi();
}


void cNaytto::paivita_jasenmaksuja(char valinta)
{
  otsikko(valinta,"Pivit jsenmaksuja");
  ei_toimi();
}


void cNaytto::avustus(char valinta)
{
  otsikko(valinta,"Avustus");
  ei_toimi();
}


void cNaytto::paamenu()
{
  cout << "\n\n\n\n" << endl;
  cout << "Jsenrekisteri" << endl;
  cout << "==============" << endl;
  cout << endl;
  cout << "Kerhossa " << kerho->Kerhon_nimi() << " on " <<
          kerho->Jasenia() << " jsent." << endl;
  cout << endl;
  cout << "Valitse:" << endl;
  cout << "   ?  = avustus" << endl;
  cout << "   0  = lopetus" << endl;
  cout << "   1  = lis uusi jsen" << endl;
  cout << "   2  = etsi jsenen tiedot" << endl;
  cout << "   3  = tulosteet" << endl;
  cout << "   4  = tietojen korjailu" << endl;
  cout << "   5  = pivit jsenmaksuja" << endl;
  cout << "   :";
}


int cNaytto::paavalinta()
{
  char nappain;

  while (1) {

    paamenu();

    nappain = odota_nappain("?012345",EI_OLETUSTA,MERKKI_ISOKSI);

    switch (nappain) {
      case '?': avustus(nappain);               break;
      case '0': return 0;
      case '1': lisaa_uusi_jasen(nappain);      break;
      case '2': etsi_jasenen_tiedot(nappain);   break;
      case '3': tulosteet(nappain);             break;
      case '4': tietojen_korjailu(nappain);     break;
      case '5': paivita_jasenmaksuja(nappain);  break;
      default : cout << "Nin ei voi kyd!" << endl; return 1;
    }

  }
}

  
int main(void)
{
  cKerho kerho;
  cNaytto naytto(&kerho);
  naytto.ohjeet();

  if ( naytto.lue_tiedosto() ) return 1;

  naytto.paavalinta();

  if ( naytto.talleta() ) return 2;

  naytto.kiitokset();

  return 0;
}

